<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
      <!--<el-button v-waves :loading="downloading" class="filter-item" type="primary" icon="el-icon-download" @click="handleDownload">-->
      <!--{{ $t('table.export') }}-->
      <!--</el-button>-->
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column align="center" :label="$t('form.province')">
        <template slot-scope="scope">
          <span>{{ scope.row.province }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('form.city')">
        <template slot-scope="scope">
          <span>{{ scope.row.city }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.address')">
        <template slot-scope="scope">
          <span>{{ scope.row.address }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.region')">
        <template slot-scope="scope">
          <span>{{ scope.row.region }}</span>
        </template>
      </el-table-column>

      <!--<el-table-column align="center" :label="$t('form.subscriptionNumber')">-->
      <!--<template slot-scope="scope">-->
      <!--<span>{{ scope.row.counter }}</span>-->
      <!--</template>-->
      <!--</el-table-column>-->

      <!--<el-table-column align="center" :label="$t('form.geoPlace')">-->
      <!--<template slot-scope="scope">-->
      <!--<span>{{ scope.row.geo_place }}</span>-->
      <!--</template>-->
      <!--</el-table-column>-->

      <el-table-column align="center" :label="$t('form.status')">
        <template slot-scope="scope">
          <span>{{ $t('form.' + scope.row.status) }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('row.operation')">
        <template slot-scope="scope">
          <span class="pointer fa fa-trash mr-1 ml-1" @click="removeAddress(scope.row.id)">&nbsp;</span>
          <router-link :to="`/address/${scope.row.id}/counters`">
            <span class="pointer fa fa-bars mr-1 ml-1">&nbsp;</span>
          </router-link>
        </template>
      </el-table-column>

    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Address from '@/api/address';
const addresResource = new Address('address');
import 'vue-select/src/scss/vue-select.scss';
import i18n from '@/lang';

export default {
  name: 'AddressList',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      listTransfer: null,
      total: 0,
      newTransfer: {},
      listTransferQuery: {},
      listLoading: true,
      listTransferLoading: false,
      dialogFormVisible: false,
      dialogFormListVisible: false,
      transferAddress: false,
      address: {},
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await addresResource.list(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    removeAddress(id) {
      this.address = id;
      this.$confirm(i18n.t(`dialog.isDelete`), i18n.t(`dialog.warning`), {
        confirmButtonText: i18n.t(`dialog.confirm`),
        cancelButtonText: i18n.t(`dialog.cancel`),
        type: 'warning',
      })
        .then(async() => {
          addresResource.destroy(this.address);
          this.getList();
        })
        .catch(err => {
          console.error(err);
        });
    },
    addCounters(id) {
      alert(id);
      this.address = id;
      this.$confirm(i18n.t(`dialog.isDelete`), i18n.t(`dialog.warning`), {
        confirmButtonText: i18n.t(`dialog.confirm`),
        cancelButtonText: i18n.t(`dialog.cancel`),
        type: 'warning',
      })
        .then(async() => {
          addresResource.destroy(this.address);
          this.getList();
        })
        .catch(err => {
          console.error(err);
        });
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
